<template>
  <div class="mb-2">
    <label
      :id="labelFor + 'Label'"
      class="form-label d-inline-flex gap-1 align-items-center"
      :for="labelFor"
      >{{ $t(entry.labelKey) }} <i-bi-question-circle-fill
    /></label>
    <b-tooltip :target="labelFor + 'Label'" triggers="hover" noninteractive>{{
      $t(entry.descriptionKey)
    }}</b-tooltip>
    <b-form-select
      v-if="entry.items"
      :id="labelFor"
      :options="entry.items"
      :placeholder="$t(entry.labelKey)"
      :model-value="value"
      :disabled="readonly"
      @update:modelValue="updateProperty(entry, $event)"
    >
      <template #first>
        <b-form-select-option :value="''" disabled>{{
          $t("pleaseSelectOption")
        }}</b-form-select-option>
      </template>
    </b-form-select>
    <PropertyList
      v-else-if="entry.type === 'list'"
      :id="labelFor"
      :application-profile="applicationProfile"
      :given-entry="entry"
      :placeholder="$t(entry.labelKey)"
      :readonly="readonly"
      :selections="selections"
      :model-value="value"
      @change="updateDefinition"
      @update:modelValue="updateProperty(entry, $event)"
    />
    <b-form-select
      v-else-if="entry.type === 'boolean'"
      :id="labelFor"
      :placeholder="$t(entry.labelKey)"
      :model-value="value"
      :disabled="readonly"
      @update:modelValue="updateProperty(entry, $event)"
    >
      <template #first>
        <b-form-select-option :value="''">{{
          $t("pleaseSelectOption")
        }}</b-form-select-option>
        <b-form-select-option :value="'true'">{{
          $t("true")
        }}</b-form-select-option>
        <b-form-select-option :value="'false'">{{
          $t("false")
        }}</b-form-select-option>
      </template>
    </b-form-select>
    <b-input-group v-else-if="entry.searchType">
      <SearchSelect
        :id="labelFor"
        :application-profile="applicationProfile"
        :readonly="readonly"
        :type="entry.searchType"
        :model-value="value"
        @update:modelValue="updateProperty(entry, $event)"
      />
      <template v-if="entry.type === 'url'" #append>
        <b-button :href="value" target="_blank" variant="outline-secondary">
          <i-bi-link45deg />
        </b-button>
      </template>
    </b-input-group>
    <div v-else-if="entry.localized">
      <b-input-group
        v-for="locale in ['de', 'en']"
        :key="locale"
        :append="locale"
        class="mb-1 localeGroup"
      >
        <b-form-textarea
          v-if="entry.multiline"
          :id="labelFor"
          :placeholder="$t(entry.labelKey)"
          :model-value="localeValues[locale]"
          trim
          :type="entry.type"
          :disabled="readonly"
          :max="max"
          :min="min"
          @change="updateDefinition"
          @update:modelValue="updateProperty(entry, $event, locale)"
        />
        <b-form-input
          v-else
          :id="labelFor"
          :placeholder="$t(entry.labelKey)"
          :model-value="localeValues[locale]"
          trim
          :type="entry.type"
          :disabled="readonly"
          :max="max"
          :min="min"
          @change="updateDefinition"
          @update:modelValue="updateProperty(entry, $event, locale)"
        />
      </b-input-group>
    </div>
    <b-input-group v-else>
      <b-form-textarea
        v-if="entry.multiline"
        :id="labelFor"
        :placeholder="$t(entry.labelKey)"
        :model-value="value"
        trim
        :state="state"
        :type="entry.type"
        :disabled="readonly"
        :max="max"
        :min="min"
        @change="updateDefinition"
        @update:modelValue="updateProperty(entry, $event)"
      />
      <b-form-input
        v-else
        :id="labelFor"
        :placeholder="$t(entry.labelKey)"
        :model-value="value"
        trim
        :state="state"
        :type="entry.type"
        :disabled="readonly"
        :max="max"
        :min="min"
        @change="updateDefinition"
        @update:modelValue="updateProperty(entry, $event)"
      />
      <template v-if="entry.type === 'url'" #append>
        <b-button :href="value" target="_blank" variant="outline-secondary">
          <i-bi-link45deg />
        </b-button>
      </template>
    </b-input-group>
  </div>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { ShaclProperty } from "@/types/shape-properties";
import type { Dataset, Quad_Object, Quad_Subject } from "@rdfjs/types";

import { defineComponent, type PropType } from "vue";

import {
  convertToSelectionType,
  getObject,
  getObjectSelectionTypeList,
  getObjectStringList,
} from "@/util/linkedData";
import { defaultDataType, type SelectionType } from "@/util/shaclTypes";
import { isURI } from "@/util/uriCheck";

export default defineComponent({
  name: "PropertyRenderer",
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    entry: {
      required: true,
      type: Object as PropType<ShaclProperty>,
    },
    readonly: {
      required: true,
      type: Boolean,
    },
    selectedProperty: {
      required: true,
      type: Object as PropType<Quad_Subject>,
    },
  },
  data() {
    return {
      currentValue: "" as string | string[],
      labelFor: "render" + (Math.random() + 1).toString(36).slice(7),
    };
  },
  computed: {
    localeValues(): { [locale: string]: string } {
      const localeValues = { en: "", de: "" };
      const objects = getObject(
        this.selectedProperty,
        this.entry.predicate,
        this.definition,
      ).map((quad) => quad.object);
      for (const object of objects) {
        if (object.termType === "Literal") {
          localeValues[object.language as "en" | "de"] = object.value;
        }
      }
      return localeValues;
    },
    max(): number | undefined {
      if (this.entry.max !== undefined) {
        if (typeof this.entry.max === "number") {
          return this.entry.max;
        } else {
          const objects = getObject(
            this.selectedProperty,
            this.entry.max,
            this.definition,
          );
          if (objects.length > 0) {
            return Number(objects[0].object.value);
          }
        }
      }
      return undefined;
    },
    min(): number | undefined {
      if (this.entry.min !== undefined) {
        if (typeof this.entry.min === "number") {
          return this.entry.min;
        } else {
          const objects = getObject(
            this.selectedProperty,
            this.entry.min,
            this.definition,
          );
          if (objects.length > 0) {
            return Number(objects[0].object.value);
          }
        }
        return 0;
      }
      return undefined;
    },
    selections(): SelectionType | SelectionType[] {
      let matches = [];
      if (this.entry.type === "list") {
        return getObjectSelectionTypeList(
          this.selectedProperty,
          this.entry.predicate,
          this.definition,
        );
      } else {
        matches = getObject(
          this.selectedProperty,
          this.entry.predicate,
          this.definition,
        );
      }

      // If a match is found, it is assumed to only have one. Therefore the first result is returned.
      for (const matchedValue of matches) {
        return convertToSelectionType(matchedValue.object);
      }
      return defaultDataType;
    },
    state(): boolean | undefined {
      if (this.entry.type === "url" && this.currentValue !== "") {
        return this.validUri;
      } else if (
        this.entry.type === "url" &&
        this.currentValue === "" &&
        this.entry.deletable === false
      ) {
        return false;
      }
      return undefined;
    },
    validUri(): boolean {
      return Array.isArray(this.currentValue)
        ? this.currentValue.every((entry) => isURI(entry))
        : isURI(this.currentValue);
    },
    value(): string | string[] {
      let matches = [];
      if (this.entry.type === "list") {
        return this.entry.listType === "linked"
          ? getObjectStringList(
              this.selectedProperty,
              this.entry.predicate,
              this.definition,
            )
          : getObject(
              this.selectedProperty,
              this.entry.predicate,
              this.definition,
            ).map((quad) => quad.object.value);
      } else {
        matches = getObject(
          this.selectedProperty,
          this.entry.predicate,
          this.definition,
        );
      }

      // If a match is found, it is assumed to only have one. Therefore the first result is returned.
      for (const matchedValue of matches) {
        return matchedValue.object.value;
      }
      return "";
    },
  },
  watch: {
    value() {
      this.currentValue = this.value;
    },
  },
  mounted() {
    this.currentValue = this.value;
  },
  methods: {
    updateDefinition() {
      if (this.state !== false) {
        this.$emit("updateDefinition");
      }
    },
    updateProperty(
      entry: ShaclProperty,
      value: string | Quad_Object[],
      locale?: string,
    ) {
      this.currentValue = Array.isArray(value)
        ? value.map((entry) => entry.value)
        : value;
      if (this.state !== false) {
        this.$emit(
          "updateProperty",
          entry,
          value,
          this.value !== value,
          locale ?? this.$i18n.locale,
        );
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
label {
  margin-top: 0.325rem;
}
.localeGroup :deep(.input-group-text) {
  width: 2.7rem;
}
</style>
